Subject: Re: Detecting TCP loss on the receiving side?

From: Rick Jones <[email-masked]>
Date: Thu, 10 Jul 2008 14:20:07 -0700

John Heffner wrote:
> Looking for loss at the receiver is a bit tricky.  It doesn't look
> like struct tcp_info has enough information to do this easily.  If you
> are able to install a custom kernel on this machine, the Web100 patch
> would be able to gather enough information to figure it out.  The
> basic idea would be to look for a difference between RcvNxt and
> RcvMax.

And even then it depends on the connections having multiple segments in 
flight at one time.  Although I suppose that cuts both ways and affects 
the tracing too, but perhaps not to the same extent.

Dan - seeing "brokerage" in your email and worries about latency makes 
me think that your app(s) are pushing around lots of small messages - 
are those spread-out across lots of connections, or are they 
consolidated into a rather smaller number of connections?  Also, what is 
the magnitude of the latency in these latency events?

rick jones